package ConverterLib;

public class AngleConverter extends Converter {
	public static final int DEGREE_TO_RADIAN = 1;
	public static final int RADIAN_TO_DEGREE = 2;
	
	public AngleConverter() {
		this.type = ConverterType.ANGLE_CONVERTER;
		convert();
	}

	public AngleConverter(int mode, double value) {
		this.type = ConverterType.ANGLE_CONVERTER;
		if (mode == DEGREE_TO_RADIAN) {
			this.fromUnit = "DEGREE";
			this.toUnit = "RADIAN";
		} else if (mode == RADIAN_TO_DEGREE) {
			this.fromUnit = "RADIAN";
			this.toUnit = "DEGREE";
		}
		this.fromValue = value;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	public AngleConverter(String fromUnit, String toUnit, double fromValue) {
		this.type = ConverterType.ANGLE_CONVERTER;
		this.fromUnit = fromUnit;
		this.toUnit = toUnit;
		this.fromValue = fromValue;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	@Override
	public void convert() {
    	this.fromUnit =  UserInput.getConverterUnit("Please select FROM (DEGREE, RADIAN): ");
    	this.toUnit =  UserInput.getConverterUnit("Please select TO (DEGREE, RADIAN): ");
		System.out.printf("Please enter angle (%s): ", fromUnit);
		this.fromValue = UserInput.getDouble();
		this.toValue = convert(fromUnit, toUnit, fromValue);
		System.out.printf("%s = %f => %s = %f\n", fromUnit, fromValue, toUnit, toValue);
	}

	@Override
	public double convert(String fromUnit, String toUnit, double fromValue) {
		if  (fromUnit.equalsIgnoreCase("DEGREE")) {
			if (toUnit.equalsIgnoreCase("RADIAN")) {
				return fromDegreeToRadian(fromValue);
			} 
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("RADIAN")) {
			if (toUnit.equalsIgnoreCase("DEGREE")) {
				return fromRadianToDegree(fromValue);
			} 
			return fromValue;
		}
		return fromValue;
	}
	
	@Override
	public double convertFrom(double value) { // degree -> radian
		return fromDegreeToRadian(value);
	}

	@Override
	public double convertTo(double value) { // radian -> degree
		return fromRadianToDegree(value);
	}

	static double fromDegreeToRadian(double degree) {
        return (degree * Math.PI / 180.0);
    }

    static double fromRadianToDegree(double radian) {
        return (radian * 180.0f / Math.PI);
    }
}
