package ConverterLib;

public class TemperatureConverter extends Converter {
	public static final int CELSIUS_TO_FAHRENHEIT = 1;
	public static final int FAHRENHEIT_TO_CELSIUS = 2;
	public static final int KELVIN_TO_CELSIUS = 3;
	public static final int CELSIUS_TO_KELVIN = 4;
	public static final int FAHRENHEIT_TO_KELVIN = 5;
	public static final int KELVIN_TO_FAHRENHEIT = 6;
	
	public TemperatureConverter() {
		type = ConverterType.TEMPERATURE_CONVERTER;
		convert();
	}
	
	public TemperatureConverter(int mode, double value) {
		this.type = ConverterType.TEMPERATURE_CONVERTER;
		if (mode == CELSIUS_TO_FAHRENHEIT) {
			this.fromUnit = "CELSIUS";
			this.toUnit = "FAHRENHEIT";
		} else if (mode == FAHRENHEIT_TO_CELSIUS) {
			this.fromUnit = "FAHRENHEIT";
			this.toUnit = "CELSIUS";
		} else if (mode == KELVIN_TO_CELSIUS) {
			this.fromUnit = "KELVIN";
			this.toUnit = "CELSIUS";
		} else if (mode == CELSIUS_TO_KELVIN) {
			this.fromUnit = "CELSIUS";
			this.toUnit = "KELVIN";
		} else if (mode == FAHRENHEIT_TO_KELVIN) {
			this.fromUnit = "FAHRENHEIT";
			this.toUnit = "KELVIN";
		} else if (mode == KELVIN_TO_FAHRENHEIT) {
			this.fromUnit = "KELVIN";
			this.toUnit = "FAHRENHEIT";
		}
		this.fromValue = value;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	public TemperatureConverter(String fromUnit, String toUnit, double fromValue) {
		this.type = ConverterType.TEMPERATURE_CONVERTER;
		this.fromUnit = fromUnit;
		this.toUnit = toUnit;
		this.fromValue = fromValue;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}
    
    @Override
	public void convert() {
    	this.fromUnit =  UserInput.getConverterUnit("Please select FROM (CELSIUS, FAHRENHEIT, KELVIN): ");
    	this.toUnit =  UserInput.getConverterUnit("Please select TO (CELSIUS, FAHRENHEIT, KELVIN): ");
		System.out.printf("Please enter temperature (%s): ", fromUnit);
		this.fromValue = UserInput.getDouble();
		this.toValue = convert(fromUnit, toUnit, fromValue);
		System.out.printf("%s = %f => %s = %f\n", fromUnit, fromValue, toUnit, toValue);
	}

	@Override
	public double convert(String fromUnit, String toUnit, double fromValue) {
		if  (fromUnit.equalsIgnoreCase("CELSIUS")) {
			if (toUnit.equalsIgnoreCase("FAHRENHEIT")) {
				return fromCelsiusToFahrenheit(fromValue);
			} else if (toUnit.equalsIgnoreCase("KELVIN")) {
				return fromCelsiusToKelvin(fromValue);
			}
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("FAHRENHEIT")) {
			if (toUnit.equalsIgnoreCase("CELSIUS")) {
				return fromFahrenheitToCelsius(fromValue);
			} else if (toUnit.equalsIgnoreCase("KELVIN")) {
				return fromFahrenheitToKelvin(fromValue);
			}
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("KELVIN")) {
			if (toUnit.equalsIgnoreCase("CELSIUS")) {
				return fromKelvinToCelsius(fromValue);
			} else if (toUnit.equalsIgnoreCase("FAHRENHEIT")) {
				return fromKelvinToFahrenheit(fromValue);
			}
			return fromValue;
		}
		return fromValue;
	}
	
	@Override
	public double convertFrom(double value) { // celsius -> fahrenheit
		return fromCelsiusToFahrenheit(value);
	}

	@Override
	public double convertTo(double value) { // fahrenheit -> celsius
		return fromFahrenheitToCelsius(value);
	}

    static double fromCelsiusToFahrenheit(double C) {
        return ((9 / 5) * C + 32.0);
    }

    static double fromCelsiusToKelvin(double C) {
        return (C + 273.15);
    }
    
	static double fromFahrenheitToCelsius(double F) {
        return (F - 32) * (5 / 9);
    }

	static double fromFahrenheitToKelvin(double F) {
        return (F + 459.67) * 5/9;
    }
	
	static double fromKelvinToCelsius(double K) {
        return (K - 273.15);
    }

	static double fromKelvinToFahrenheit(double K) {
        return (K * 9/5 - 459.67);
    }
}
