package ConverterLib;

public class VolumeConverter extends Converter {
	public static final int LITER_TO_GALLON = 1;
	public static final int GALLON_TO_LITER = 2;

	public VolumeConverter() {
		type = ConverterType.VOLUME_CONVERTER;
		convert();
	}
	
	public VolumeConverter(int mode, double value) {
		this.type = ConverterType.VOLUME_CONVERTER;
		if (mode == LITER_TO_GALLON) {
			this.fromUnit = "LITER";
			this.toUnit = "GALLON";
		} else if (mode == GALLON_TO_LITER) {
			this.fromUnit = "GALLON";
			this.toUnit = "LITER";
		}
		this.fromValue = value;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	public VolumeConverter(String fromUnit, String toUnit, double fromValue) {
		this.type = ConverterType.VOLUME_CONVERTER;
		this.fromUnit = fromUnit;
		this.toUnit = toUnit;
		this.fromValue = fromValue;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}
    
	@Override
	public void convert() {
    	this.fromUnit =  UserInput.getConverterUnit("Please select FROM (LITER, GALLON): ");
    	this.toUnit =  UserInput.getConverterUnit("Please select TO (LITER, GALLON): ");
		System.out.printf("Please enter volume (%s): ", fromUnit);
		this.fromValue = UserInput.getDouble();
		this.toValue = convert(fromUnit, toUnit, fromValue);
		System.out.printf("%s = %f => %s = %f\n", fromUnit, fromValue, toUnit, toValue);
	}

	@Override
	public double convert(String fromUnit, String toUnit, double fromValue) {
		if  (fromUnit.equalsIgnoreCase("LITER")) {
			if (toUnit.equalsIgnoreCase("GALLON")) {
				return fromLiterToGallon(fromValue);
			} 
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("GALLON")) {
			if (toUnit.equalsIgnoreCase("LITER")) {
				return fromGallonToLiter(fromValue);
			} 
			return fromValue;
		}
		return fromValue;
	}
	
	@Override
	public double convertFrom(double value) { // liter -> gallon
		return fromLiterToGallon(value);
	}

	@Override
	public double convertTo(double value) { // gallon -> liter
		return fromGallonToLiter(value);
	}

	static double fromLiterToGallon(double liter) {
        return (liter * 0.26417); // US Gallons (Liquid)
    }

    static double fromGallonToLiter(double gallon) {
        return (gallon / 0.26417);
    }
}
