package ConverterLib;

public class WeightConverter extends Converter {
	public static final int KILOGRAM_TO_POUND = 1;
	public static final int POUND_TO_KILOGRAM = 2;

	public WeightConverter() {
		type = ConverterType.WEIGHT_CONVERTER;
		convert();
	}
	
	public WeightConverter(int mode, double value) {
		this.type = ConverterType.WEIGHT_CONVERTER;
		if (mode == KILOGRAM_TO_POUND) {
			this.fromUnit = "KILOGRAM";
			this.toUnit = "POUND";
		} else if (mode == POUND_TO_KILOGRAM) {
			this.fromUnit = "POUND";
			this.toUnit = "KILOGRAM";
		}
		this.fromValue = value;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}

	public WeightConverter(String fromUnit, String toUnit, double fromValue) {
		this.type = ConverterType.WEIGHT_CONVERTER;
		this.fromUnit = fromUnit;
		this.toUnit = toUnit;
		this.fromValue = fromValue;
		this.toValue = convert(fromUnit, toUnit, fromValue);
	}
   
	@Override
	public void convert() {
    	this.fromUnit =  UserInput.getConverterUnit("Please select FROM (KILOGRAM, POUND): ");
    	this.toUnit =  UserInput.getConverterUnit("Please select TO (KILOGRAM, POUND): ");
		System.out.printf("Please enter weight (%s): ", fromUnit);
		this.fromValue = UserInput.getDouble();
		this.toValue = convert(fromUnit, toUnit, fromValue);
		System.out.printf("%s = %f => %s = %f\n", fromUnit, fromValue, toUnit, toValue);
	}

	@Override
	public double convert(String fromUnit, String toUnit, double fromValue) {
		if  (fromUnit.equalsIgnoreCase("KILOGRAM")) {
			if (toUnit.equalsIgnoreCase("POUND")) {
				System.out.printf("KILOGRAM_TO_POUND \n");
				return fromKilogramToPound(fromValue);
			} 
			return fromValue;
		} else if (fromUnit.equalsIgnoreCase("POUND")) {
			if (toUnit.equalsIgnoreCase("KILOGRAM")) {
				return fromPoundToKilogram(fromValue);
			} 
			return fromValue;
		}
		return fromValue;
	}
	
	@Override
	public double convertFrom(double value) { // kilogram -> pound
		return fromKilogramToPound(value);
	}

	@Override
	public double convertTo(double value) { // pound -> kilogram
		return fromPoundToKilogram(value);
	}

	static double fromKilogramToPound(double kg) {
        return (kg / 0.45359237);
    }

    static double fromPoundToKilogram(double lbs) {
        return (lbs * 0.45359237);
    }
}
